<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use \Setforms2\Shared\ORM\DateTime;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class Pla10130AtualizaCardapioComBaseNoCicloController {
    
    protected $connectService;
    protected $util;
    
    public function __construct($connectService, $util) {
        $this->connectService = $connectService;
        $this->util           = $util;
    }

    public function getnrlogcardciclo($cdfilial){
        $returnVerificaNrLog = $this->connectService->getnrlogcardciclo($cdfilial);
        $nrLogString = intval($returnVerificaNrLog);
        $nrLogString++;
        $nrLogNumber = str_pad($nrLogString, 10, '0', STR_PAD_LEFT);
        return $nrLogNumber;
    }
    
    public function criaCardCiclo($request, $response){
        $row = $request->getRow();
        
        $dtMesCardObjeto = DateTime::createFromFormat('d/m/Y', $row['DTMESCARDAPIO']);
        
        foreach($row['UNIDADES'] as $unidade)  {
            $dataBloqCard = $this->util->retornaDataBloqueioCard($unidade, $row['DTMESCARDAPIO']);

            if ($dataBloqCard > $dtMesCardObjeto) {
                $response->addDataSet(new Dataset('cardapio_Bloqueado', array($row)));
                return;
            }
        }

        foreach($row['SERVICOS'] as $filiserv)  {
            $parts = explode('_', $filiserv);
            $cdfilial = $parts[0];
            $cdservfili = $parts[1];
            $row['NRLOG'] = $this->getnrlogcardciclo($cdfilial);
            $this->connectService->criaCardCiclo($row, $cdfilial, $cdservfili);
        }
        $response->addDataSet(new DataSet('procedure', array($row)));

    }
}